//
//  SKUserClientInterface.m
//  SecondaryKeyboard
//
//  Created by narita on 2013/05/12.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "SKUserClientInterface.h"

#define KEXT_CLASS_NAME "com_mindto01_minimal01_driver"

@implementation SKUserClientInterface

- (void) findIOService
{
    kern_return_t	theKernErr;
    
    CFMutableDictionaryRef theDict = NULL;

    theDict = IOServiceMatching(KEXT_CLASS_NAME);
    
    if( theDict )
    {
        io_iterator_t 	theIterator = 0;

        theKernErr = IOServiceGetMatchingServices(
                                                  kIOMasterPortDefault,
                                                  theDict,
                                                  &theIterator);
        
        if (theKernErr == KERN_SUCCESS)
        {
            while( (_ioService = IOIteratorNext(theIterator)) != IO_OBJECT_NULL )
            {
                break;
            }
            
            if( theIterator )
            {
                IOObjectRelease(theIterator);
                theIterator = 0;
            }
        }
    }
}

- (kern_return_t) open
{
    kern_return_t theKernErr = KERN_FAILURE;

    [self findIOService];
    
    if( _ioService )
    {        
        theKernErr = IOServiceOpen(_ioService,
                                   mach_task_self(),
                                   0,
                                   &_ioConnect);

        if( _ioConnect != IO_OBJECT_NULL && theKernErr == KERN_SUCCESS )
        {
            theKernErr = IOConnectCallScalarMethod(_ioConnect,
                                                   kSKUserClientOpen,
                                                   NULL,
                                                   0,
                                                   NULL,
                                                   NULL);
            
            return theKernErr;
        }
    }
    
    return theKernErr;
}


- (kern_return_t) close
{
    kern_return_t theKernErr = KERN_FAILURE;
	
    theKernErr = IOConnectCallScalarMethod(_ioConnect,
                                           kSKUserClientClose,
                                           NULL,
                                           0,
                                           NULL,
                                           NULL);
    
    if( theKernErr == KERN_SUCCESS )
    {
        theKernErr = IOServiceClose(_ioConnect);
        _ioConnect = 0;
    }
    
    
    return theKernErr;
}

- (BOOL) isOpend
{
    if(_ioConnect != IO_OBJECT_NULL)
    {
        return YES;
    }
    else
    {
        return NO;
    }
}

//
- (void) setGlobalSwitch:(BOOL)inYesNo
{
    if( [self isOpend] )
    {
        uint64_t	scalarI_64[1];

        scalarI_64[0] = (inYesNo == YES);

        IOConnectCallScalarMethod(_ioConnect,
                                  kSKUserClientSetGlobalSwitch,
                                  scalarI_64,
                                  1,
                                  NULL,
                                  NULL);
    }
}

- (BOOL) globalSwitch
{
    if( [self isOpend] )
    {        
        kern_return_t theResult;

        uint64_t	scalarO_64;
		uint32_t	outputCount = 1;
                        
        theResult = IOConnectCallScalarMethod(_ioConnect,
                                  kSKUserClientGlobalSwitch,
                                  NULL,
                                  0,
                                  &scalarO_64,
                                  &outputCount);

        return ( scalarO_64 != 0 );
    }
    
    return NO;
}


@end
