
#ifndef _KE_LOG_H
#define _KE_LOG_H

#include <IOKit/IOBufferMemoryDescriptor.h>


#define KE_Enter()   IOLog("%s(%p)::%s Enter\n", this->getMetaClass()->getClassName(), this, __FUNCTION__);
#define KE_Exit()    IOLog("%s(%p)::%s Exit\n", this->getMetaClass()->getClassName(), this, __FUNCTION__);



#define KE_Trace_Int(inValue) IOLog("%s(%p)::%s | %s = %d\n", \
                                             this->getMetaClass()->getClassName(), this, __FUNCTION__, #inValue, inValue);

#define KE_Trace_Hex(inValue) IOLog("%s(%p)::%s | %s = 0x%x\n", \
                                    this->getMetaClass()->getClassName(), this, __FUNCTION__, #inValue, inValue);


#define KE_Trace_Bool(inBool) IOLog("%s(%p)::%s | %s = %s\n", \
                                             this->getMetaClass()->getClassName(), this, __FUNCTION__, #inBool, \
                                             inBool ? "TRUE" : "FALSE");

#define KE_Trace_Str(inStr) IOLog("%s(%p)::%s | %s = %s\n", \
                                             this->getMetaClass()->getClassName(), this, __FUNCTION__, #inStr, inStr);

#define KE_Trace_Ptr(inPtr) IOLog("%s(%p)::%s | %s = %p\n", \
                                             this->getMetaClass()->getClassName(), this, __FUNCTION__, #inPtr, inPtr);

#define KE_Trace_Msg(inMsg) IOLog("%s(%p)::%s | %s\n", \
                                  this->getMetaClass()->getClassName(), this, __FUNCTION__, inMsg);


#define KE_Trace_Block(inBlockPtr, inBlockLen) _KE_Trace_Block( this->getMetaClass()->getClassName() , this,\
                                                                __FUNCTION__, #inBlockPtr,\
                                                                inBlockPtr,\
                                                                inBlockLen);

#define KE_Trace_MemDscrpt(inMemDscrpt) _KE_Trace_MemDscrpt( this->getMetaClass()->getClassName(), this,\
                                                             __FUNCTION__, #inMemDscrpt,\
                                                             inMemDscrpt);


void _KE_Trace_Block(const char * inLabel, void* inThis, const char * inFuncName, const char * inValueName,
                            const char * inBuffer, int inLength);

void _KE_Trace_MemDscrpt(const char * inLabel, void* inThis, const char * inFuncName, const char * inValueName,
                                IOMemoryDescriptor * inBuffer);


// for static function
#define KE_Enter_Static()   IOLog("%s Enter\n", __FUNCTION__);
#define KE_Exit_Static()    IOLog("%s Exit\n", __FUNCTION__);

#define KE_Trace_Int_Static(inValue) IOLog("%s | %s\ = %d\n", \
                                            __FUNCTION__, #inValue, inValue);

#define KE_Trace_Hex_Static(inValue) IOLog("%s | %s = 0x%x\n", \
                                            __FUNCTION__, #inValue, inValue);


#define KE_Trace_Bool_Static(inBool) IOLog("%s | %s = %s\n", \
                                            __FUNCTION__, #inBool, \
                                           inBool ? "TRUE" : "FALSE");

#define KE_Trace_Str_Static(inStr) IOLog("%s | %s = %s\n", \
                                          __FUNCTION__, #inStr, inStr);

#define KE_Trace_Ptr_Static(inPtr) IOLog("%s | %s = %p\n", \
                                          __FUNCTION__, #inPtr, inPtr);

#define KE_Trace_Msg_Static(inMsg) IOLog("%s | %s\n", \
                                          __FUNCTION__, inMsg);



#define KE_Trace_Block_Static(inBlockPtr, inBlockLen) _KE_Trace_Block_Static(  NULL,\
                                                                        __FUNCTION__, #inBlockPtr,\
                                                                        inBlockPtr,\
                                                                        inBlockLen);

#define KE_Trace_MemDscrpt_Static(inMemDscrpt) _KE_Trace_MemDscrpt_Static(NULL,\
                                                                        __FUNCTION__, #inMemDscrpt,\
                                                                        inMemDscrpt);


#endif //_KE_LOG_H
