//
//  com_mindto01_minimal01_driver.h
//  com_mindto01_minimal01_driver
//
//  Created by narita on 2013/04/24.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#ifndef __minimal01__minimal01__
#define __minimal01__minimal01__

#include <IOKit/IOService.h>
#include <IOKit/IOLib.h>

class com_mindto01_minimal01_driver : public IOService
{
    OSDeclareDefaultStructors(com_mindto01_minimal01_driver)
public:
    virtual bool		init(OSDictionary *dictionary = 0);
    virtual void		free(void);
    virtual IOService*	probe(IOService *provider, SInt32 *score);
    virtual bool		start(IOService *provider);
    virtual void		stop(IOService *provider);

    
    
    virtual bool matchedNotificationHandler(IOService* newService,
                                            IONotifier* notifier);
    
    virtual bool terminatedNotificationHandler(IOService* newService,
                                               IONotifier* notifier);

protected:
    IONotifier* notifier_hookKeyboard_;
    IONotifier* notifier_unhookKeyboard_;
    
    //
    static bool staticMatchedNotificationHandler(void* target,
                                                 void* refCon,
                                                 IOService* newService,
                                                 IONotifier* notifier);
    
    static bool staticTerminatedNotificationHandler(void* target,
                                                    void* refCon,
                                                    IOService* newService,
                                                    IONotifier* notifier);
};

typedef com_mindto01_minimal01_driver SKDriver;

#endif /* defined(__minimal01__minimal01__) */


