//
//  com_mindto01_minimal01_keyboardRemaper.h
//  minimal01
//
//  Created by narita on 2013/04/30.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#ifndef __minimal01__com_mindto01_minimal01_keyboardRemaper__
#define __minimal01__com_mindto01_minimal01_keyboardRemaper__

#include <IOKit/IOLib.h>
#include <libkern/c++/OSObject.h>
#include <libkern/c++/OSSymbol.h>
#include <IOKit/hidsystem/IOHIKeyboard.h>

class com_mindto01_minimal01_keyboardRemaper : public OSObject
{
    OSDeclareDefaultStructors(com_mindto01_minimal01_keyboardRemaper)
public:
    static com_mindto01_minimal01_keyboardRemaper* withKeyboard(IOHIKeyboard* inKeyboard);
    virtual bool		init(IOHIKeyboard* inKeyboard);
    virtual void		free();
    
    
    bool isReplaced();
    void replaceKeyboardEventAction();
    void restoreKeyboardEventAction();
    
    // インスタンスな置換えコールバック
    void keyboardEventCallback(
                               /* target */           OSObject * target,
                               /* eventFlags  */      unsigned   eventType,
                               /* flags */            unsigned   flags,
                               /* keyCode */          unsigned   key,
                               /* charCode */         unsigned   charCode,
                               /* charSet */          unsigned   charSet,
                               /* originalCharCode */ unsigned   origCharCode,
                               /* originalCharSet */  unsigned   origCharSet,
                               /* keyboardType */     unsigned   keyboardType,
                               /* repeat */           bool       repeat,
                               /* atTime */           AbsoluteTime ts,
                               /* sender */           OSObject * sender,
                               /* refcon */           void *     refcon);
    
protected:
    //
    IOHIKeyboard*       keyboard;
    const OSSymbol*     symbol;
    
    
    
    //
    const OSNumber* venderID;
    const OSNumber* productID;
    
    const OSString* manufacturerString;
    const OSString* productString;
    
    const OSNumber* locationID;
    
    
    
    // 元のkeyEventActionへのポインター
    KeyboardEventCallback originalEventAction;
    
    
    
    // static な置換えキーボードコールバック
    static void static_KeyboardEventCallback(
                                             /* target */           OSObject * target,
                                             /* eventFlags  */      unsigned   eventType,
                                             /* flags */            unsigned   flags,
                                             /* keyCode */          unsigned   key,
                                             /* charCode */         unsigned   charCode,
                                             /* charSet */          unsigned   charSet,
                                             /* originalCharCode */ unsigned   origCharCode,
                                             /* originalCharSet */  unsigned   origCharSet,
                                             /* keyboardType */     unsigned   keyboardType,
                                             /* repeat */           bool       repeat,
                                             /* atTime */           AbsoluteTime ts,
                                             /* sender */           OSObject * sender,
                                             /* refcon */           void *     refcon);
};

typedef com_mindto01_minimal01_keyboardRemaper SKKeyboardRemaper;

#endif /* defined(__minimal01__com_mindto01_minimal01_keyboardRemaper__) */
