//
//  SKUserClient.h
//  minimal01
//
//  Created by narita on 2013/05/07.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#ifndef __minimal01__SKUserClient__
#define __minimal01__SKUserClient__

#include <IOKit/IOService.h>
#include <IOKit/IOUserClient.h>
#include "SKDriver.h"
#include "../../../SKUserKernelShared.h"


class com_mindto01_minimal01_userClient : public IOUserClient
{
    OSDeclareDefaultStructors(com_mindto01_minimal01_userClient)

    
protected:
    SKDriver*					            fProvider;
    task_t									fTask;
    static const IOExternalMethodDispatch	sMethods[kNumberOfMethods];
    
public:
    // IOUserClient methods
    virtual void stop(IOService* provider);
    virtual bool start(IOService* provider);
    
	virtual bool initWithTask(task_t owningTask, void* securityToken, UInt32 type, OSDictionary* properties);
    
    virtual IOReturn clientClose(void);
    virtual IOReturn clientDied(void);
    
	virtual bool willTerminate(IOService* provider, IOOptionBits options);
	virtual bool didTerminate(IOService* provider, IOOptionBits options, bool* defer);
	
    virtual bool terminate(IOOptionBits options = 0);
    virtual bool finalize(IOOptionBits options);
	
protected:
    virtual IOReturn externalMethod(uint32_t selector,
                                    IOExternalMethodArguments* arguments,
									IOExternalMethodDispatch* dispatch,
                                    OSObject* target,
                                    void* reference);
    

	static IOReturn sOpenUserClient(com_mindto01_minimal01_userClient* target,
                                    void* reference,
                                    IOExternalMethodArguments* arguments);
    
	virtual IOReturn openUserClient(void);
    
    
    
	static IOReturn sCloseUserClient(com_mindto01_minimal01_userClient* target,
                                     void* reference,
                                     IOExternalMethodArguments* arguments);
    
    virtual IOReturn closeUserClient(void);
    

    
    
    // 
	static IOReturn sGlobalSwitch(com_mindto01_minimal01_userClient* target,
                                  void* reference,
                                  IOExternalMethodArguments* arguments);
    virtual bool    globalSwitch(void);

    
	static IOReturn sSetGlobalSwitch(com_mindto01_minimal01_userClient* target,
                                     void* reference,
                                     IOExternalMethodArguments* arguments);
    virtual void    setGlobalSwitch(bool inBool);
    
    
    
    
    
	static IOReturn sScalarIStructO(com_mindto01_minimal01_userClient* target,
                                    void* reference,
                                    IOExternalMethodArguments* arguments);
    
	virtual IOReturn ScalarIStructO(uint32_t inNumber1,
                                    uint32_t inNumber2,
                                    MySampleStruct* outStruct,
                                    uint32_t* outStructSize);
    
};


typedef com_mindto01_minimal01_userClient SKUserClient;

#endif /* defined(__minimal01__SKUserClient__) */
