//
//  SKUtility.cpp
//  minimal01
//
//  Created by narita on 2013/04/30.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#include <libkern/c++/OSObject.h>
#include <libkern/c++/OSSymbol.h>
#include "SKUtility.h"

namespace SKUtility
{
    // c++のデストラクタを利用してヒープ上のオブジェクトを自動でリリースする
    StOSRelease::StOSRelease(OSObject* inObject)
    {
        mObject = inObject;
    }

    StOSRelease::StOSRelease(const OSObject* inObject)
    {
        mObject = const_cast<OSObject*>(inObject);
    }

    StOSRelease::~StOSRelease()
    {
        OSSafeReleaseNULL(mObject);
    }
    
    // オブジェクトのポインターを利用してシンボルを生成する
    const OSSymbol* symbolFromObject(OSObject* inObject)
    {
        const OSSymbol* theSymbol;
        char 		    theCString[20];
        
        snprintf(theCString, 20, "%p", inObject);
        theSymbol = OSSymbol::withCString(theCString);

        return theSymbol;
    }
}
